//
// ViewControllerMain.h
// ====================
// main controller component of matrixProjection
//
//  AUTHOR: Song Ho Ahn (song.ahn@gmail.com)
// CREATED: 2017-11-01
// UPDATED: 2017-11-07
//
// Copyright (c) 2017 Song Ho Ahn. All rights reserved.
///////////////////////////////////////////////////////////////////////////////

#import <Cocoa/Cocoa.h>
#import "ModelGL.h"
#import "ViewGL.h"

@interface ViewControllerMain : NSViewController

@property (nonatomic) ModelGL modelGL;
@property (weak) IBOutlet ViewGL* viewGL;

@property (weak) IBOutlet NSButton* radioPerspective;
@property (weak) IBOutlet NSButton* radioOrthographic;
@property (weak) IBOutlet NSButton* radioFill;
@property (weak) IBOutlet NSButton* radioLine;
@property (weak) IBOutlet NSButton* radioPoint;

@property (weak) IBOutlet NSSlider* sliderLeft;
@property (weak) IBOutlet NSSlider* sliderRight;
@property (weak) IBOutlet NSSlider* sliderBottom;
@property (weak) IBOutlet NSSlider* sliderTop;
@property (weak) IBOutlet NSSlider* sliderNear;
@property (weak) IBOutlet NSSlider* sliderFar;

@property (weak) IBOutlet NSTextField* labelLeft;
@property (weak) IBOutlet NSTextField* labelRight;
@property (weak) IBOutlet NSTextField* labelBottom;
@property (weak) IBOutlet NSTextField* labelTop;
@property (weak) IBOutlet NSTextField* labelNear;
@property (weak) IBOutlet NSTextField* labelFar;

@property (weak) IBOutlet NSImageView* imageMatrix;

- (IBAction)resetParameters:(id)sender;
- (IBAction)setProjectionMode:(id)sender;
- (IBAction)setRenderingMode:(id)sender;
- (IBAction)updateParameters:(id)sender;

- (void)updateProjectionMatrix;

@end

